#include <stdio.h>
#include <math.h>
#define pi 3.14159265359

typedef struct {
   double r;
   double t;
   double x;
   double y;
} Position;

void rect(double *,double *,double *,double *);
void polar(double *,double *,double *,double *);


int main(int argc, char *argv[])
{
   double r, t, x, y;
   Position base,elbow,wrist,shoulder,total;
   int data[6],i,temp;
   FILE *cfPtr;
   char esc = 27;
   
   printf("\n");

   while(1)
   {

      // Get Lock File
      cfPtr = fopen("/home/robot/public_html/lock.dat", "r");
      fscanf(cfPtr,"%d",&temp);
      printf("Lock: %i\n",temp);
      fclose(cfPtr);

      printf("           Base    Elbow    Wrist    W_Rot Shoulder  Gripper\n");   
      // retrieve current possition
      if ((cfPtr = fopen("/home/robot/public_html/robot_position.dat", "r")) == NULL)
         printf("File could not be opened\n");
      else
      {
         printf("steps ");
         for(i=0;i<6;i++)
         {
            fscanf(cfPtr,"%d",&data[i]);
            printf("%+9i",data[i]);
         }
         printf("\n");
      }
      
      printf("angle            %+7.1f  %+7.1f           %+7.1f         \n",(float)data[1]*0.032,(float)data[2]*0.045,(float)data[4]*0.039);

      base.x=0;
      base.y=9.5;
      base.r=9.5;
      base.t=0;
      printf("Body: %lg,%lg                                  \n",0.0,9.5);

      t=shoulder.t=(float)data[4]*0.0407;
      r=shoulder.r=7.5;
      rect(&r,&t,&x,&y);      
      shoulder.x=x;
      shoulder.y=y;
      printf("Shoulder: %lg,%lg                            \n",x,y);

      t=elbow.t=(float)data[1]*0.0324;
      r=elbow.r=7.5;
      rect(&r,&t,&x,&y);      
      elbow.x=x;
      elbow.y=y;
      printf("Elbow: %lg,%lg                          \n",x,y);

      t=wrist.t=(float)data[2]*0.0402;
      r=wrist.r=4.5;
      rect(&r,&t,&x,&y);      
      wrist.x=x;
      wrist.y=y;
      printf("Wrist: %lg,%lg                      \n",x,y);

      total.x=wrist.x+elbow.x+shoulder.x;
      total.y=wrist.y+elbow.y+shoulder.y;
      x=total.x;
      y=total.y;
      polar(&x,&y,&r,&t);
      total.r=r;
      total.t=t;

      printf("Total (Position): %lg,%lg    %lg < %lg                       \n",x,y,r,t);


      fclose(cfPtr);
      sleep(1);
      printf("\r");
      printf("%c%s",esc,"[9A");      //ANSI escape code for cursor up 2x
   }
   return 0;
}


/*	Polar/Rectangular conversion
	A program to convert between Polar and Rectangular
	coordinates, with a menu to allow the user to choose
	which conversion will be performed.
	
	Author: Daniel Soskel
	Date: 3/2/09  */
	
/* Function to convert from polar to rect */

void rect(double *r, double *t, double *x, double *y)
{
   *x = *r*(cos(*t*pi/180));
   *y = *r*(sin(*t*pi/180));
}

/* Function to convert from rect to polar */

void polar(double *x, double *y, double *r, double *t)
{
   *r = sqrt((*x * *x)+(*y * *y));
   *t = atan(*y / *x);
   *t = *t * (180/pi);		/* Convert radians to degrees */
}
